// E-TELSA - A Program to Calculate the Resonant Frequency of Tesla Coils
// This program is released to the public domain
//
// Great thanks to Jim Monte for numerous help and tips
//
// Great thanks to John Damm Soerensen <jdsoerensen@geocities.com>
// for a major speed improvement
//
// Great thanks to Kevin Ottalini for the very fast compiler version
//
// Ported to C++ by Sarah Thompson - needs Qt 1.4 or later (I used Qt 2.01, but 1.4 should be OK)
//
// Sarah's code butchered by Terry to get rid of QTthing and remove functions I didn't understand :-))
//   this allows it to compile under my shareware C thing so I can play with the code too! :-))
// Sarah showed me how to get it to run giant arrays ;-))
// Now with secondary voltage correction!  A simple secondary voltage average before line33000.


#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>

#define REV " V5.50C  June 6, 2000 "
#define mathtype float

int main()

{

	int CountInc = 1000; // The number of passes between printouts
	float Qstr;
	int MultD = 0;
	float Cf1 = 0.0;
	float pi = 3.14159265359;
	float Cap1 = 1E-15;
	double Et = 0.0;
	float TermVM = 0.0;
	double xr = 0.0, yr = 0.0, CircFac = 0.0;
	double vs1 = 0.0, vr = 0.0, vs2 = 0.0, vs = 0.0, Qt = 0.0;
    float Cap = 0.0, Fo = 0.0, Str = 0.0, y_zero = 0.0;
	float Acc = 0.0;
	float Erp = 100.0;
    double Mult = 0.0;
	float Bare = 0.0;
	float Ceil = 0.0;
	float Wall = 0.0;
	double AcF = 0.0;
	float PriH = 0.0;
	float PriD0 = 0.0;
	float PriD = 0.0;
	float PriH1 = 0.0;
	float SecB = 0.0;
	float SecD = 0.0;
	float SecL = 0.0;
	float StriH = 0.0;
	float StriD = 0.0;
	float SecInd = 0.0;
	float TermH = 0.0;
	float TermH2 = 0.0, TermR = 0.0, TermD = 0.0, TermR2 = 0.0, TermV = 0.0, TermD2 = 0.0;
	float Htot = 0.0;
	float g0 = 0.0;
	float z=0.0;
	double Q=0.0;
	float Sfact=0.0;
	float ts=0.0;
	float x=0.0, y=0.0;
	double Vr1 = 0.0, Vr2= 0.0, Vr3 = 0.0, Vr4 = 0.0, Dr1 = 0.0, Dr2=0.0, Dr3=0.0, Dr4=0.0;
	double Qtt;
	int zz = 0, zpcnt = 0, Qnum = 0;
	long count = 0;

    printf(" E-TESLA - Tesla Coil Resonant Frequency Calculator\n" REV "\n\n");

line1000:

line2000:
	printf(" Input an ARRAY SIZE 50 (min) to 1000 (or more...).\n");
	printf(" The higher the number, the longer it takes to calculate.\n");

    scanf( "%f", &Acc );

	if(Acc < 50.0 || Acc > 100000.0)
	{
		Acc = floor(Acc);
		printf(" Must be between 50 and 100000!\n");
		goto line2000;
	}

	printf(" Input the measurement UNITs you are using.\n");
    printf(" 1 = mm\n");
    printf(" 2 = cm\n");
    printf(" 3 = inches\n");
    printf(" 4 = feet\n");
    printf(" 5 = meters\n");
    printf(" All dimension inputs will be in these units.\n");

line2100:
	printf(" Units ");

	scanf( "%d", &MultD );

	switch((int) MultD)
	{
	case 1:
		Mult = 0.0393700787402;
		break;

	case 2:
		Mult = 0.393700787402;
		break;

	case 3:
		Mult = 1.0;
		break;

	case 4:
		Mult = 12.0;
		break;

	case 5:
		Mult = 39.3700787402;
		break;

	default:
		printf(" Try again!\n");
		goto line2100;
	}

line2150:
	printf(" Is the secondary BARE or TERMINATED?\n");

    printf(" 1 = BARE\n");
    printf(" 2 = TERMINATED\n");

	scanf( "%f", &Bare );

    if(Bare != 1.0 && Bare != 2.0)
	{
		printf(" Must input 1 or 2!\n");
		goto line2150;
	}

    if(Bare == 2.0)
	{
		Bare = 0;
	}

line2200:
	printf(" How HIGH is the CEILING?\n");

    scanf( "%f", &Ceil );

    if(Ceil <= 0)
	{
		printf(" Must be greater than zero!\n");
		goto line2200;
	}

line2300:
	printf(" How FAR are the WALLs from the coil?\n");

    scanf( "%f", &Wall );

    if(Wall <= 0)
	{
		printf(" Must be greater than zero!\n");
		goto line2300;
	}

    if(2.0 * Wall < Ceil)
	{
		printf(" The walls are too close to the coil!\n");
		goto line2300;
	}

    AcF = sqrt(Acc * Acc / Ceil / Wall);

line2400:
  	printf(" What is the HEIGHT from the floor to the INNER TURN of the PRIMARY coil?\n");

    scanf( "%f", &PriH );

    if(PriH < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2400;
	}

line2500:
	printf(" What is the INNER DIAMETER of your PRIMARY coil?\n");

    scanf( "%f", &PriD0 );

    if(PriD0 < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2500;
	}

line2600:
	printf(" What is the OUTER DIAMETER of your PRIMARY coil?\n");

    scanf( "%f", &PriD );
    if(PriD < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2600;
	}

line2700:
	printf(" What is the HEIGHT from the floor to the OUTER TURN of the PRIMARY?\n");

    scanf( "%f", &PriH1 );

    if(PriH1 < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2700;
	}

line2710:
	printf(" What is the HEIGHT from the floor to the STRIKE RAIL (0 if none)?\n");

	scanf( "%f", &StriH );

	if(StriH < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2710;
	}

line2720:
	printf(" What is the DIAMETER of the the STRIKE RAIL loop (0 if none)?\n");

	scanf( "%f", &StriD );

	if(StriD < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2720;
	}

line2800:
	printf(" What is the HEIGHT from the floor to the FIRST WINDING of the SECONDARY coil?\n");

    scanf( "%f", &SecB );

    if(SecB < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line2800;
	}

line2900:
	printf(" What is the DIAMETER of your SECONDARY coil?\n");

    scanf( "%f", &SecD );

	if(SecD < 0)
	{
		printf(" Must be greater than or equal to zero!");
		goto line2900;
	}

line3000:
	printf(" What is the LENGTH of your SECONDARY coil?\n");

    scanf( "%f", &SecL );
    if(SecL < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3000;
	}

line3100:
	printf(" What is the INDUCTANCE in MILLI-HENRIES of the SECONDARY?\n");

    scanf( "%f", &SecInd );

    SecInd = SecInd / 1000.0;

    if(SecInd <= 0)
	{
		printf(" Must be greater than zero!\n");
		goto line3100;
	}

    if(Bare == 1.0)
	{
		TermH = SecB + SecL;
		TermH2 = TermH;
		goto line3800;
	}

line3200:
	printf(" What is the HEIGHT from the floor to the CENTER of the FIRST TOP TERMINAL?\n");

    scanf( "%f", &TermH );

    if(TermH < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3200;
	}

    if(TermH == 0)
	{
		TermH = SecB + SecL;
	}

line3300:
	printf(" What is the DIAMETER of the FIRST TERMINAL (sphere or toroid cord)?\n");

    scanf( "%f", &TermR );

    if(TermR < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3300;
	}
	TermR = TermR / 2.0;

line3400:
	printf(" What is the CENTER to CENTER DIAMETER of the TOROID?\n");
    printf(" Enter 0 if it is a sphere.\n");

    scanf( "%f", &TermD );

    if(TermD < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3400;
	}

line3500:
	printf(" What is the HEIGHT from the floor to the CENTER of the SECOND TOP TERMINAL?\n");

    scanf( "%f", &TermH2 );

    if(TermH2 < 0)
	{
		printf(" Must be greater than or equal to zero!");
		goto line3500;
	}

    if(TermH2 < TermH)
	{
		TermH2 = TermH;
	}

line3600:
	printf(" What is the DIAMETER of the SECOND TERMINAL (sphere or toroid cord)?\n");

    scanf( "%f", &TermR2 );

    if(TermR2 < 0)
	{
		printf(" Must be greater than or equal to zero!");
		goto line3600;
	}
	TermR2 = TermR2 / 2.0;

line3700:
	printf(" What is the CENTER to CENTER DIAMETER of the TOROID?\n");
    printf(" Enter 0 if it is a sphere.\n");

    scanf( "%f", &TermD2 );

    if(TermD2 < 0)
	{
		printf(" Must be greater than or equal to zero!\n");
		goto line3700;
	}

line3800:
    TermV = 1.0;
    printf(" What is the TOP VOLTAGE (enter 1 for default)?\n");

    scanf( "%f", &TermV );

    if(TermV < 1.0)
	{
		printf(" Must be greater than or equal to 1!\n");
		goto line3800;
	}

    printf(" Grid Size = %lf\n", Acc );
    printf(" Scale Multiplier = %lf\n", Mult);

    if(Bare)
	{
		printf(" Bare Coil\n");
	}
	else
	{
		printf(" Terminated Coil\n");
	}

    printf(" Ceiling Height = %lf\n", Ceil);
    printf(" Wall Distance = %lf\n", Wall);
    printf(" Primary Height (Inner Turn) = %lf\n", PriH);
    printf(" Primary Inner Diameter = %lf\n", PriD0);
    printf(" Primary Outer Diameter = %lf\n", PriD);
    printf(" Primary Height (Outer Turn) = %lf\n", PriH1);
	printf(" Strike Rail Height = %1f\n", StriH);
	printf(" Strike Rail Diameter = %1f\n", StriD);
    printf(" Secondary Base Height = %lf\n", SecB);
    printf(" Secondary Diameter = %lf\n", SecD);
    printf(" Secondary Length = %lf\n", SecL);
    printf(" Secondary Inductance (mH) = %lf\n", SecInd * 1000.0);
    printf(" Terminal-1 Height (center) = %lf\n", TermH);
    printf(" Terminal-1 Cord Diameter = %lf\n", 2.0 * TermR);
    printf(" Terminal-1 C-C Diameter (toroid only) = %lf\n", TermD);
    printf(" Terminal-2 Height (center) = %lf\n", TermH2);
    printf(" Terminal-2 Cord Diameter = %lf\n", 2.0 * TermR2);
    printf(" Terminal-2 C-C Diameter (toroid only) = %lf\n", TermD2);
    printf(" Top Voltage = %lf\n", TermV);

	if(Wall > Ceil)
		{
			printf(" WARNING! - Walls are further than the ceiling height.\n");
		}

	if(SecL < 0.25 * Ceil)
		{
			printf(" WARNING! - Coil is less than 1/4 of the room height.\n");
		}

    printf(" Is this correct (y=1/n=0) ?\n");

	scanf( "%f", &Qstr );

    if(Qstr == 0.0)
	{
		goto line1000;
	}

// Factor Acf so coil diameter falls directly on grid points

    AcF = AcF * floor(AcF * SecD / 2.0) / (AcF * SecD / 2.0);

// Store Inputs to File
	FILE *f = fopen("output.txt", "w");

    fprintf(f, " E-TESLA " REV "\n");
    fprintf(f, "  \n");
    fprintf(f, " Grid Size = %lf\n", Acc );
    fprintf(f, " Scale Multiplier = %lf\n", Mult);

    if(Bare)
	{
		fprintf(f, " Bare Coil\n");
	}
	else
	{
		fprintf(f, " Terminated Coil\n");
	}

    fprintf(f, " Ceiling Distance = %lf\n", Ceil);
	Ceil = floor(Ceil * AcF + 0.5);

    fprintf(f, " Wall Distance = %lf\n", Wall);
	Wall = floor(Wall * AcF + 0.5);

    fprintf(f, " Primary Height (Inner Turn) = %lf\n", PriH);
	PriH = floor(PriH * AcF + 0.5);

    fprintf(f, " Primary Inner Diameter = %lf\n", PriD0);
	PriD0 = floor(PriD0 * AcF + 0.5);

    fprintf(f, " Primary  Outer Diameter = %lf\n", PriD);
	PriD = floor(PriD * AcF + 0.5);

    fprintf(f, " Primary Height (Outer Turn) = %lf\n", PriH1);
	PriH1 = floor(PriH1 * AcF + 0.5);

	fprintf(f, " Strike Rail Height = %1f\n", StriH);
	StriH = floor(StriH * AcF + 0.5);

	fprintf(f, " Strike Rail Diameter = %1f\n", StriD);
	StriD = floor(StriD * AcF + 0.5);

    fprintf(f, " Secondary Base Height = %lf\n", SecB);
	SecB = floor(SecB * AcF + 0.5);

    fprintf(f, " Secondary Diameter = %lf\n", SecD);
	SecD = SecD * AcF;

    fprintf(f, " Secondary Length = %lf\n", SecL);
	SecL = floor(SecL * AcF + .5);

    fprintf(f, " Secondary Inductance (mH) = %lf\n", SecInd * 1000.0);

    fprintf(f, " Terminal-1 Height (center) = %lf\n", TermH);
	TermH = floor(TermH * AcF + .5);

    fprintf(f, " Terminal-1 Cord Diameter = %lf\n", 2.0 * TermR);
	TermR = TermR * AcF;

    fprintf(f, " Terminal-1 C-C Diameter (toroid only)= %lf\n", TermD);
	TermD = TermD * AcF;

    fprintf(f, " Terminal-2 Height (center) = %lf\n", TermH2);
	TermH2 = floor(TermH2 * AcF + .5);

    fprintf(f, " Terminal-2 Cord Diameter = %lf\n", 2.0 * TermR2);
	TermR2 = TermR2 * AcF;

    fprintf(f, " Terminal-2 C-C Diameter (toroid only)= %lf\n", TermD2);
	TermD2 = TermD2 * AcF;

    fprintf(f, " Top Voltage = %lf\n", TermV);

//    fprintf(f, " Pass"; TAB(10); "Ccalc (pF)"; TAB(30); "% Change"; TAB(50); "Fcalc (Hz)"
    fprintf(f, " Pass     Ccalc (pF)          Change            Fcalc (Hz)\n");

	fclose(f);

// Htot is the total effective height of the coil
// g0 is the radius of the Gaussian sphere

    Htot = TermR + TermD / 2.0 + TermH;

    if(Htot < TermH2 + TermR2 + TermD2 / 2.0)
	{
		Htot = TermH2 + TermR2 + TermD2 / 2.0;
	}

    g0 = floor(((Htot - SecB) + (Ceil - SecB)) / 4.0 + 0.5);

    printf(" Calculations are now under way!\n\n");

	printf(" Type CONTROL-C to stop.\n\n");

    printf(" Pass     Ccalc (pF)          Change            Fcalc (Hz)\n");

	mathtype **a;
	int **p;



	int i,j;
	int xsize = ((int)Wall) + 4; // I'm adding one to the size here just in case...
	int ysize = ((int)Ceil) + 4; // Terry already over padded it :-)

	a = (mathtype **) calloc(xsize, sizeof(mathtype *));
	p = (int **) calloc(xsize, sizeof(int *));

	for(i=0; i<xsize; i++)
	{
		a[i] = (mathtype *) calloc(ysize, sizeof(mathtype *));
		p[i] = (int *) calloc(ysize, sizeof(mathtype *));

		for(j=0; j<ysize; j++)
		{
			a[i][j] = 0.0;
			p[i][j] = 0;
		}
	}

// Set initial conditions and lock bondaries

// Primary Coil

    for(z = PriD0 / 2.0; z <= PriD / 2.0; z++)
	{
	    Q = PriD / 2.0 - SecD / 2.0;

	    a[(int)(z+0.5)][(int)((PriH + (PriH1 - PriH) * (z - SecD / 2) / Q)+0.5)] = 0.0;
	    p[(int)(z+0.5)][(int)((PriH + (PriH1 - PriH) * (z - SecD / 2) / Q)+0.5)] = 1;
	}

// Strike Rail
	a[(int)(StriD / 2 + 0.5)][(int)(StriH / 2 + 0.5)] =0.0;
	p[(int)(StriD / 2 + 0.5)][(int)(StriH / 2 + 0.5)] =1;

// Voltage Along Secondary
    for(z = SecB; z <= SecB + SecL; z++)
	{
	    if(Bare == 0.0)
		{
			TermVM = TermV * pow(((SecL + SecD / 2) / SecL), 2.71828);
		}
		else
		{
			TermVM = TermV;
		}

	    a[(int)(0.5 + SecD / 2.0)][(int)(z + 0.5)] = TermV * TermV /
								TermVM * pow(((z - SecB + SecD / 2.0) / SecL), 2.71828);

	    Sfact = TermV * sin(pi / 2 * (z - SecB) / SecL);

	    if(Bare == 1.0 && Sfact < a[(int)(SecD / 2.0)][(int)(z)])
		{
			a[(int)(0.5 + SecD / 2.0)][(int)(z+0.5)] = Sfact;
		}

	    p[(int)(0.5 + SecD / 2.0)][(int)(z+0.5)] = 1;
	}

// Top of Secondary to Top Terminal-1
    for(z = SecB + SecL; z <= TermH; z++)
	{
	    a[(int)(0)][(int)(z+0.5)] = TermV;
	    p[(int)(0)][(int)(z+0.5)] = 1.0;
	}

// Out to Radius-1
    for(z = 0; z <= TermD / 2.0; z++)
	{
	    a[(int)(z+0.5)][(int)(TermH+0.5)] = TermV;
	    p[(int)(z+0.5)][(int)(TermH+0.5)] = 1.0;
	}

// Terminal-1 Radius
    for(z = -pi / 2.0; z <= pi / 2.0; z += 0.0785)
	{
	    x = TermD / 2.0 + TermR * cos(z);
		y = TermH + TermR * sin(z);

	    a[(int)(x+0.5)][(int)(y+0.5)] = TermV;
	    p[(int)(x+0.5)][(int)(y+0.5)] = 1.0;

	    if(TermD / 2.0 + 1.0 >= TermR) // Comparison swapped from < to >= to avoid need for goto -- SJT
		{
		    x = TermD / 2.0 - TermR * cos(z);
		    a[(int)(x+0.5)][(int)(y+0.5)] = TermV;
		    p[(int)(x+0.5)][(int)(y+0.5)] = 1.0;
		}
	}

    a[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH + TermR)] = TermV;
    a[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH - TermR)] = TermV;

    p[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH + TermR)] = 1.0;
    p[(int)(0.5 + TermD / 2.0)][(int)(0.5 + TermH - TermR)] = 1.0;

// Top of Terminal-1 to Top of Terminal-2
    for(z = TermH; z <= TermH2; z++)
	{
	    a[(int)(0)][(int)(0.5 + z)] = TermV;
	    p[(int)(0)][(int)(0.5 + z)] = 1.0;
	}

// Out to Radius-2
    for(z = 0.0; z <= TermD2 / 2.0; z++)
	{
	    a[(int)(0.5 + z)][(int)(0.5 + TermH2)] = TermV;
	    p[(int)(0.5 + z)][(int)(0.5 + TermH2)] = 1;
	}

// Terminal-2 Radius
    for(z = -pi / 2.0; z <= pi / 2.0; z += 0.0785)
	{
	    x = TermD2 / 2.0 + TermR2 * cos(z);
		y = TermH2 + TermR2 * sin(z);

	    a[(int)(0.5 + x)][(int)(0.5 + y)] = TermV;
	    p[(int)(0.5 + x)][(int)(0.5 + y)] = 1.0;

	    if(TermD2 / 2.0 + 1.0 >= TermR2) // Comparison sign changed from < to >= to avoid goto -- SJT
		{
		    x = TermD2 / 2.0 - TermR2 * cos(z);
		    a[(int)(0.5 + x)][(int)(0.5 + y)] = TermV;
		    p[(int)(0.5 + x)][(int)(0.5 + y)] = 1.0;
		}
	}

    a[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 + TermR2)] = TermV;
    a[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 - TermR2)] = TermV;
    p[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 + TermR2)] = 1.0;
    p[(int)(0.5 + TermD2 / 2.0)][(int)(0.5 + TermH2 - TermR2)] = 1.0;

// Mark Gaussian surface on protection array for diagnostics
    y_zero = g0 + PriH + 0.5;

    for(ts = -1.57; ts <= 1.57; ts += .001)
	{
	    xr = cos(ts) * (g0 - 0.5);
	    yr = sin(ts) * (g0 - 0.5) + y_zero;
	    p[(int)(0.5 + xr)][(int)(0.5 + yr)] = -1;
	}

// Output the diagnostic grid to a file for Excel
	FILE *df = fopen("diag.xls", "w");

	int xpcnt, ypcnt;

    for(ypcnt = Ceil; ypcnt >= 0; ypcnt--)
	{
		for(xpcnt = Wall; xpcnt >= 0; xpcnt--)
		{
		    fprintf(df, "%d ", p[xpcnt][ypcnt]);
		}

	    // Mirror left side
	    for(xpcnt = 1; xpcnt <= Wall; xpcnt++)
		{
		    fprintf(df, "%d ", p[xpcnt][ypcnt]);
		}

	    fprintf(df, "\n");
	}

	fclose(df);


// 30000 'Main Loop
line30000:

    for(zz = 1; zz <= CountInc; zz++)
	{
	    for(ypcnt = 1; ypcnt <= Ceil - 1.0; ypcnt ++)
		{
			for(xpcnt = 1; xpcnt <= Wall - 1.0; xpcnt++)
			{
			    if(p[xpcnt][ypcnt] <= 0) // Sign flipped to avoid goto
				{
				    a[(int)(xpcnt)][(int)(ypcnt)] = 0.25 * (a[(int)(xpcnt + 1)][(int)(ypcnt)]
						+ a[(int)(xpcnt - 1)][(int)(ypcnt)]
						+ a[(int)(xpcnt)][(int)(ypcnt + 1)]
						+ a[(int)(xpcnt)][(int)(ypcnt - 1)]);

				    a[(int)(xpcnt)][(int)(ypcnt)] = a[(int)(xpcnt)][(int)(ypcnt)]
						+ (a[(int)(xpcnt + 1)][(int)(ypcnt)] - a[(int)(xpcnt - 1)][(int)(ypcnt)])
						/ ((float)(8.0 * xpcnt));
				}
			}
		}

	    for(zpcnt = 1; zpcnt <= Ceil - 1; zpcnt++)
		{
		    if(p[0][zpcnt] <= 0) // Sign flipped to avoid goto
			{
			    a[(int)(0)][(int)(zpcnt)] = (4.0 * a[(int)(1)][(int)(zpcnt)] + a[(int)(0)][(int)(zpcnt - 1)] + a[(int)(0)][(int)(zpcnt + 1)]) / 6.0;
			}
		}
	}

    count = count + CountInc;

// Correct Secondary Voltage Profile

	if(Cf1 != 0.0 || Erp > 1.0)
		{
			goto line33000;
		}

	printf(" Secondary Voltage Correction\n");

	xpcnt = (int)(SecD / 2 + 0.5);

	for(ypcnt = (int)( SecB + 0.5); ypcnt <= (int)(SecB + SecL + 0.5); ypcnt++)
		{
			a[(int)(xpcnt)][(int)(ypcnt)] = (a[(int)(xpcnt - 1)][(int)(ypcnt)] + a[(int)(xpcnt + 1)][(int)(ypcnt)]) / 2.0;
		}

	Cf1 = TermV / a[(int)(xpcnt)][(int)(SecB + SecL + 0.5)];

	for(ypcnt = (int)( SecB + 0.5); ypcnt <= (int)(SecB + SecL + 0.5); ypcnt++)
		{
			a[(int)(xpcnt)][(int)(ypcnt)] = a[(int)(xpcnt)][(int)(ypcnt)] * Cf1;
		}

// Calculate E-field by summing all flux through a sphere

line33000:

    Et = 0.0;
    y_zero = g0 + PriH + 0.5;

    for(ts = -1.5708; ts <= 1.5708; ts += .0001)
	{
    	// CircFac is the area of the section of the sphere
	    CircFac = (sin(ts + 0.00005) - sin(ts - 0.00005));

	    xr = cos(ts) * (g0 - 0.5);
	    yr = sin(ts) * (g0 - 0.5) + y_zero;

			Vr1 = a[(int)(xr)][(int)(yr)];
     		Vr2 = a[(int)(xr + 1)][(int)(yr)];
     		Vr3 = a[(int)(xr)][(int)(yr + 1)];
     		Vr4 = a[(int)(xr + 1)][(int)(yr + 1)];
     		Dr1 = sqrt(pow(floor(xr), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr2 = sqrt(pow(floor(xr + 1.0), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr3 = sqrt(pow(floor(xr), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));
     		Dr4 = sqrt(pow(floor(xr + 1.0), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));

     		Qtt = (Vr1 / Dr1 + Vr2 / Dr2 + Vr3 / Dr3 + Vr4 / Dr4) / 4.0;

     		vr = Qtt * sqrt(pow(xr, 2.0) + pow((yr - y_zero), 2.0));

	    vs1 = vr;
	    xr = cos(ts) * (g0 + 0.5);
	    yr = sin(ts) * (g0 + 0.5) + y_zero;

			Vr1 = a[(int)(xr)][(int)(yr)];
     		Vr2 = a[(int)(xr + 1)][(int)(yr)];
     		Vr3 = a[(int)(xr)][(int)(yr + 1)];
     		Vr4 = a[(int)(xr + 1)][(int)(yr + 1)];
     		Dr1 = sqrt(pow(floor(xr), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr2 = sqrt(pow(floor(xr + 1.0), 2.0) + pow((floor(yr) - y_zero), 2.0));
     		Dr3 = sqrt(pow(floor(xr), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));
     		Dr4 = sqrt(pow(floor(xr + 1.0), 2.0) + pow(floor(yr + 1) - y_zero, 2.0));

     		Qtt = (Vr1 / Dr1 + Vr2 / Dr2 + Vr3 / Dr3 + Vr4 / Dr4) / 4.0;

     		vr = Qtt * sqrt(pow(xr, 2.0) + pow((yr - y_zero), 2.0));

	    vs2 = vr;
	    vs = (vs1 - vs2);
	    Et = Et + vs * CircFac;
	}

    Et = Et * 6.5797362674 * g0 * g0 / AcF / 39.3700787402;
	// 6.5797... = 2/3pi^2

// Calculate the capacitance

    Qt = 8.854187818E-12 * Et * Mult;
    Cap = Qt / TermV;
    Erp = (Cap - Cap1) / Cap1 * 100.0;
    if(Cap < 0.0)
	{
		Fo = 0.0;
	}
	else
	{
	    Fo = 1.0 / (2.0 * pi * sqrt(SecInd * Cap));
	}

	printf("%6d   ", count);
    printf("C=%3.5f       Err%%=%4.6f       F=%7.2f\n", Cap * 1E+12, Erp, Fo);

	FILE *fo = fopen("output.txt", "a");

	fprintf(fo, "%6d   ", count);
    fprintf(fo, "C=%3.5f       Err%%=%4.6f       F=%7.2f\n", Cap * 1E+12, Erp, Fo);

    Cap1 = Cap;

	fclose(fo);

// Output the whole voltage grid space to a file for Excel
	FILE *vo = fopen("voutput.xls", "w");

    for(ypcnt = Ceil; ypcnt >= 0; ypcnt--)
	{
		for(xpcnt = Wall; xpcnt >= 0; xpcnt --)
		{
		    fprintf(vo, "%lf ", a[(int)(xpcnt)][(int)(ypcnt)]);
		}

	    // Mirror left side
	    for(xpcnt = 1; xpcnt <= Wall; xpcnt ++)
		{
		    fprintf(vo, "%lf ", a[(int)(xpcnt)][(int)(ypcnt)]);
		}

	    fprintf(vo, "\n");
	}

	fclose(vo);

// Output the whole stress grid space to a file for Excel
	FILE *so = fopen("soutput.xls", "w");

    for(ypcnt = Ceil - 1; ypcnt >= 1; ypcnt--)
	{
		for(xpcnt = Wall - 1; xpcnt >= 1; xpcnt--)
		{
		    Str = (fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt - 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt + 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt + 1)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt - 1)])) / 4.0;

		    fprintf(so, "%lf ", Str * AcF);
		}

	    // Mirror left side
	    for(xpcnt = 1; xpcnt <= Wall - 1; xpcnt++)
		{
		    Str = (fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt - 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt + 1)][(int)(ypcnt)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt + 1)])
					+ fabs(a[(int)(xpcnt)][(int)(ypcnt)] - a[(int)(xpcnt)][(int)(ypcnt - 1)])) / 4.0;

	    	fprintf(so, "%lf ", Str * AcF);
		}

    	fprintf(so, "\n");
	}

	fclose(so);

    if(Erp < 0.0001)
	{
		goto line49999;
	}

	goto line30000;

line49999:

    printf(" type any key and press return ?\n");
	scanf( "%s", &Qstr );
 	return 0;

}


